LIBRARY ieee ;
USE ieee.std_logic_1164.all;


ENTITY digital_filter IS
 PORT (
      CHA 	: IN std_logic;
      CHB	: IN std_logic;
      Clk	: IN std_logic;
      RST	: IN std_logic;
      CHA_filt 	: OUT std_logic;
      CHB_filt	: OUT std_logic
      
    );
END digital_filter;

ARCHITECTURE arch_digital_filter OF digital_filter IS

SIGNAL temp_CHA: std_logic;     
SIGNAL  temp_CHB: std_logic;       

BEGIN

Channel_A:PROCESS(CLK, RST)
  VARIABLE Afilter: std_logic_vector(0 to 3);
  BEGIN
    IF RST = '0' THEN
      Afilter := "0000";
      temp_CHA <= '0';
    ELSIF (CLK'event AND CLK = '1') THEN
        Afilter(1 to 3) := Afilter(0 to 2);
        Afilter(0) := CHA;
        IF Afilter(1 to 3) = "000" THEN
          temp_CHA <= '0';
        END IF;
        IF  Afilter(1 to 3) = "111" THEN
          temp_CHA <= '1';
        END IF;
    END IF;
  END PROCESS;

  CHA_filt <= temp_CHA;

Channel_B:PROCESS(CLK, RST)
  VARIABLE Bfilter: std_logic_vector(0 to 3);
  BEGIN
    IF RST = '0' THEN
      Bfilter := "0000";
      temp_CHB <= '0';
    ELSIF (CLK'event AND CLK = '1') THEN
        Bfilter(1 to 3) := Bfilter(0 to 2);
        Bfilter(0) := CHB;
        IF Bfilter(1 to 3) = "000" THEN
          temp_CHB <= '0';
        END IF;
        IF  Bfilter(1 to 3) = "111" THEN
          temp_CHB <= '1';
        END IF;
    END IF;
  END PROCESS;
  CHB_filt <= temp_CHB;

  END arch_digital_filter;
