library ieee ;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

ENTITY Position_counter IS
    generic (WIDTH   : integer := 16);
    port(	
        RST      : IN std_logic;
        CLK      : IN std_logic;
        ENABLE   : IN std_logic;
        UP_DOWN  : IN std_logic;
        Q_count  : OUT std_logic_vector (15 downto 0)
      );
END position_counter ;

ARCHITECTURE behv OF position_counter IS
 

SIGNAL Qtmp	: std_logic_vector(15 downto 0);
SIGNAL RCO 	: std_logic;

BEGIN
PROCESS(Clk,rst,up_down,qtmp,enable)
   	begin
	     if(rst = '0') then
                Qtmp <= "0000000000000000";
	         elsif (CLK = '1' and CLK'event) then
                         if (UP_DOWN = '1' and enable ='1') then
                                Qtmp <= Qtmp + '1';
                        elsif (UP_DOWN = '0' and enable ='1') then 
                                Qtmp <= Qtmp - '1';
                        end if;
                end if;
   	end process;

         Q_count <= Qtmp;

   PROCESS(Qtmp,UP_DOWN,rco)
      begin
                if (Qtmp = CONV_STD_LOGIC_VECTOR(-1,WIDTH)and up_down ='1') then
                        RCO <= '1';
                else
                        RCO <= '0';
          end if;

        
               if (Qtmp = CONV_STD_LOGIC_VECTOR(0,WIDTH) and up_down ='0') then
                        RCO <= '1';
                else
                        RCO <= '0';
                end if;

   end process;
        
end behv;
