LIBRARY ieee ;
USE ieee.std_logic_1164.all;
 
ENTITY Quad_decoder IS
    PORT (
      filt_A 	: IN std_logic;
      filt_B	: IN std_logic;
      Clk	: IN std_logic;
      rst	: IN std_logic;
      Count	: OUT std_logic;
      Updown	: OUT std_logic
    );
END Quad_decoder;

ARCHITECTURE behavior OF quad_decoder IS

TYPE DecoderStates is (S0, S1, S2, S3);
SIGNAL PresentState: DecoderStates;
SIGNAL up_down: std_logic;       
 SIGNAL cnt: std_logic;        

BEGIN


Decode:PROCESS(clk,rst,presentstate,up_down,cnt,filt_a,filt_b)
  BEGIN
    IF rst = '0' THEN
        PresentState <= S0;
        Up_Down <= '0';
        Cnt <= '0';
    ELSE
	IF (Clk'event AND Clk = '0') THEN 
        CASE PresentState is
          WHEN S0 => IF filt_A = '1' THEN         
                       PresentState <= S1;
                       Up_Down <= '1';
                       Cnt <= '1';
                     ELSIF filt_B = '1' THEN
                       PresentState <= S3;
                       Up_Down <= '0';
                       Cnt <= '1';
                     ELSE 
                       Up_Down <= '0';
                       Cnt <= '0';
                     END IF;

          WHEN S1 => IF filt_B = '1' THEN       
                       PresentState <= S2;
                       Up_Down <= '1';
                       Cnt <= '1';
                     ELSIF filt_A = '0' THEN
                       PresentState <= S0;
                       Up_Down <= '0';
                       Cnt <= '1';
                     ELSE 
                       Up_Down <= '0';
                       Cnt <= '0';
                     END IF;

          WHEN S2 => IF filt_A = '0' THEN         
                       PresentState <= S3;
                       Up_Down <= '1';
                       Cnt <= '1';
                     ELSIF filt_B = '0' THEN
                       PresentState <= S1;
                       Up_Down <= '0';
                       Cnt <= '1';
                     ELSE 
                       Up_Down <= '0';
                       Cnt <= '0';
                     END IF;

          WHEN S3 => IF filt_B = '0' THEN       
                       PresentState <= S0;
                       Up_Down <= '1';
                       Cnt <= '1';
                     ELSIF filt_A = '1' THEN
                       PresentState <= S2;
                       Up_Down <= '0';
                       Cnt <= '1';
                     ELSE 
                       Up_Down <= '0';
                       Cnt <= '0';
                     END IF;
        END CASE;
        
    END IF; 
  END IF;
END PROCESS;
	updown  <=up_down;
	count <=cnt;

END behavior; 




