------------------------------------ 
-- Post-Layout Test Bench File
------------------------------------ 
-- Design : quad_top
-- Program : Figaro
-- Version : Atmel 7.5 (patch level 1 applied)
-- Vendor : Atmel
-- Created : November 7, 2001 at : 3:48:49 pm

library IEEE;
use IEEE.STD_LOGIC_1164.all;

use IEEE.VITAL_timing.all;

library AT40KAL;
--library user40kal;
use AT40KAL.VCOMPONENTS.all;

entity post_test_bench is
end post_test_bench;

architecture arch_test_bench of post_test_bench is

component quad_top_16
    port ( 
      CHA : in STD_LOGIC := 'X';
      CHB : in STD_LOGIC := 'X';
      CLK : in STD_LOGIC := 'X';
      RST : in STD_LOGIC := 'X';
      OE : in STD_LOGIC := 'X';
      SEL : in STD_LOGIC := 'X';
      inh : in STD_LOGIC := 'X';
      D : inout STD_LOGIC_VECTOR(7 downto 0);
      CNT : out STD_LOGIC;
      UP_Down : out STD_LOGIC
    );
end component;

  signal sig_D: STD_LOGIC_VECTOR(7 downto 0);
  signal sig_SEL: STD_LOGIC;
  signal sig_OE: STD_LOGIC;
  signal sig_inh: STD_LOGIC;
  signal sig_UP_Down: STD_LOGIC;
  signal sig_CNT: STD_LOGIC;
  signal sig_CHA: STD_LOGIC;
  signal sig_RST: STD_LOGIC;
  signal sig_CHB: STD_LOGIC;
  signal sig_CLK: STD_LOGIC;
  signal one : STD_LOGIC := '1';
  signal zero : STD_LOGIC := '0';

SHARED VARIABLE EndSim : BOOLEAN := false;
SHARED VARIABLE stimulus_quad : BOOLEAN := false;
CONSTANT Clk_Period : TIME := 1 us;

BEGIN

inst_quad_top:quad_top_16
port map (
CHA => sig_CHA,
CHB => sig_CHB,
CLK => sig_CLK,
RST => sig_RST,
OE => sig_OE,
SEL => sig_SEL,
inh => sig_inh,
CNT => sig_CNT,
UP_Down => sig_UP_Down,
D => sig_D
);

Clk_Generator: PROCESS
BEGIN
  IF EndSim= false THEN
    sig_clk <= '1';
    WAIT FOR Clk_Period/2;

    sig_clk <= '0';
    WAIT FOR Clk_Period/2;
  ELSE
    WAIT;
  end if;
END PROCESS;

----------------------------------------
-- Stimulus for Channel A and Channel B--
----------------------------------------
Quad: PROCESS
BEGIN
  IF stimulus_quad= true THEN
    sig_cha <= '0';
    sig_chb <= '0';
    WAIT FOR 4 us;

    sig_cha <= '1';
    sig_chb <= '0';
    WAIT FOR 4 us;
    
    sig_cha <= '1';
    sig_chb <= '1';
    WAIT FOR 4 us;
    
    sig_cha <= '0';
    sig_chb <= '1';
    WAIT FOR 4 us;
  ELSE
    WAIT FOR 1 us;
  END IF;
END PROCESS;


stimulus_process: PROCESS
BEGIN
  
  sig_rst  <= '1';
  WAIT FOR 100 ns;

  sig_rst  <= '0';
  WAIT FOR 100 ns;

  sig_rst  <= '1';
  WAIT FOR 100 ns;

sig_sel <='0';
sig_oe <='0';
sig_inh <='1';

wait for 100 ns;



  stimulus_quad := true;
  wait for 10 ms;

  stimulus_quad := false;

 WAIT FOR 1 ms;	


  
end process stimulus_process;

 
end arch_test_bench;

